#include "utiles.h"
/*
	Last modified: 2010 09 25
*/

	charRef sgets(void)
	{
		charRef puntero_linea;
		size_t longitud_linea;
		charRef resultado;
		puntero_linea = fgetln(stdin, &longitud_linea);/* No leftovers */
		resultado = (charRef)malloc(longitud_linea+2);
		memcpy(resultado,puntero_linea,longitud_linea);
		resultado[longitud_linea-1] = '\0';
		return resultado;
	}
	
	
	char getch(void) {
		struct termios conf_vieja, conf_nueva;
		char c;
		tcgetattr(0,&conf_vieja);
		conf_nueva = conf_vieja;
		conf_nueva.c_lflag &= (~ICANON);
		conf_nueva.c_cc[VTIME] = 0;
	
		conf_nueva.c_cc[VMIN] = 1;
		tcsetattr(0,TCSANOW,&conf_nueva);
		c = getchar();
		tcsetattr(0,TCSANOW,&conf_vieja);
		return c;
	}
	

charRef pedir(const charRef indicacion)
{
	charRef resultado;
	printf("%s ", indicacion);
	resultado = sgets();
	return resultado;
}

charRef pedir_nv(const charRef indicacion)
{
	charRef resultado;
	int longitud;
	do
		{
			printf("%s ", indicacion);
			resultado = sgets();
			longitud = strlen(resultado);
			if(0 == longitud)
				printf("\nPerdn, no se admite una respuesta en blanco.\n");
		} while (0 == longitud);
	return resultado;
}

int pedirInt(charRef indicacion,int limInf,int limSup)
{
	charRef linea = NULL;
	charRef temp  = NULL;
	int numero;
	do
		{
			numero = limInf-1;
			printf("(%d <= x <= %d) ",limInf,limSup);
			linea = pedir(indicacion);
			numero = strtol(linea,&temp, 10);
			free(linea);
		} while(linea == temp || numero < limInf || numero > limSup);
	return numero;
}

float pedirFloat(charRef indicacion,float limInf,float limSup)
{
	charRef linea = NULL;
	charRef temp  = NULL;
	float numero;
	do
		{
			numero = limInf -1.0;
			printf("(%.2f <= x <= %.2f) ",limInf,limSup);
			linea = pedir(indicacion);
			numero = strtof(linea,&temp);
			free(linea);
		} while(linea == temp || numero < limInf || numero > limSup);
	return numero;
}

double pedirDouble(charRef indicacion,double limInf,double limSup)
{
	charRef linea = NULL;
	charRef temp  = NULL;
	double numero;
	do
		{
			numero = limInf -1.0;
			printf("(%.2f <= x <= %.2f) ",limInf,limSup);
			linea = pedir(indicacion);
			numero = strtof(linea,&temp);
			free(linea);
		} while(linea == temp || numero < limInf || numero > limSup);
	return numero;
}

void spause(void)
{
	charRef temp;
	printf("\n\nPulse <INTRO> para continuar\n\n");
	temp = sgets();
	free(temp); /* No leaks! */
	return;
}

int confirmar(charRef indicacion)
{
	charRef respuesta;
	int resultado;
	printf("%s (s/n): ", indicacion);
	respuesta = sgets();
	resultado = toupper(respuesta[0]) == 'S';
	free(respuesta); /* No leaks! */
	return resultado;
}
