#include "uttablas.h"
/*
	Version 2010 09 25
*/
int numcampos(char * linea, char delimitador)
{
	int i, contador = 1;
	if (NULL == linea) {
		printf("\n\nNULL passed to numcampos.\n\n");
		exit(1);
	}
	for(i=0;i<strlen(linea);i++)
		if (delimitador == linea[i])
			contador++;
	return contador;
}

int cargarDocumentoDelimitado(DocumentoRef dr)
{
	char linea[1024]     = "";
	int resultado_fscanf = 0;
	int i, n             = 0;
	int maxCampos        = 0;
	FILE* fp = fopen(dr->nombreArchivo, "r");
	if(NULL == fp)
		{
		perror("documentoDelimitadoBienFormado - ");
		return 0;
		}
	n = 0;
	do {
		if(0 != (resultado_fscanf = fscanf(fp,"%[^\n]%*c",linea)))
			{
			n++;
			}
	} while(0 != resultado_fscanf);
	dr->numLineas = n;
	dr->lineas = malloc(n*sizeof(charRef));
	dr->numCampos = malloc(n*sizeof(int));
	rewind(fp);
	maxCampos = 0;
	i=0;
	do {
		fscanf(fp,"%[^\n]%*c",linea);
		if (0 != strlen(linea)) {
			dr->lineas[i] = malloc(strlen(linea)+1);
			strcpy(dr->lineas[i],linea);
			dr->numCampos[i] = numcampos(linea,dr->delimitador);
			if (dr->numCampos[i] > maxCampos)
				maxCampos = dr->numCampos[i];
			i++;
		}
	} while (i<dr->numLineas);
	fclose(fp);
	dr->registrosMalFormados = 0;
	for(i=0;i<dr->numLineas;i++)
		if (dr->numCampos[i] != maxCampos)
			{
			printf("\nError : el registro %d (%s) est mal formado.",i, dr->lineas[i]);
			dr->registrosMalFormados++;
			}
	return 0 == dr->registrosMalFormados;
}

int cargarDocumentoPorColumnas(DocumentoRef dr)
{
	charRef linea;
	int i, j                  = 0;
	int numeroDeLineas        = 0;
	charRef * lineas          = NULL;
	size_t longitud_linea     = 0;
	size_t max_longitud_linea = 0;
	int longitud_efectiva     = 0;
	int documentoBienFormado  = 1;
	FILE* fp;
	if (NULL == dr->nombreArchivo || 0 == strlen(dr->nombreArchivo)) {
		printf("\ncargarDocumentoPorColumnas - nombreArchivo NULL o vaco.\n\n");
		return 0;
	}
	fp = fopen(dr->nombreArchivo, "r");
	if (NULL == fp)
		{
		perror("cargarDocumentoPorColumnas - ");
		return 0;
		}
	longitud_linea = max_longitud_linea = 0;
	while (!feof(fp))
		{
		linea = fgetln(fp, &longitud_linea);
		if (NULL != linea)
			{
			numeroDeLineas++;
			if (longitud_linea>max_longitud_linea)
				{
				max_longitud_linea = longitud_linea;
				}
			}
		}
	lineas = malloc(numeroDeLineas*sizeof(charRef));
	rewind(fp);
	j = 0;
	for (i=0; i<numeroDeLineas; i++) {
		linea = fgetln(fp, &longitud_linea);
		if (NULL != linea) {
			longitud_efectiva = '\n' == linea[longitud_linea-1]  ? longitud_linea : longitud_linea + 1;
			lineas[j] = malloc(longitud_efectiva);
			strcpy(lineas[j], linea);
			lineas[j][longitud_efectiva-1] = '\0';
			j++;
		}
	}
	for (i=0; i<numeroDeLineas; i++) {
		if (strlen(lineas[i]) != max_longitud_linea-1) {
			printf("\nLa lnea %d (%s) no tiene longitud correcta.\n", i,lineas[i]);
			documentoBienFormado = 0;
		}
	}
	dr->numLineas = numeroDeLineas;
	dr->lineas = lineas;
	dr->longitudLinea = max_longitud_linea;
#ifdef __DEBUG__
	for (i=0; i<numeroDeLineas; i++) {
		puts(lineas[i]);
	}
#endif
	return documentoBienFormado;
}

int extraerTablaAlfanumericaDeDocumentoDelimitado(DocumentoRef dr, matRefs mrs)
{
	char delimCadena[2];
	charRef copiaDeLineaOri;
	charRef copiaDeLinea;
	charRef temp;
	int i,j;
	copiaDeLineaOri = copiaDeLinea = malloc(1024);
	if (0 == dr->numLineas || 0 == dr->numCampos[0] || NULL == dr->lineas) {
		printf("\nextraerTablaNumericaDeDocumentoDelimitado - documento incorrecto");
		return 0;
	}
	mrs->numRows = dr->numLineas;
	mrs->numCols = dr->numCampos[0];
	mrs->m = malloc(mrs->numRows*mrs->numCols*sizeof(charRef));
	delimCadena[0] = dr->delimitador;
	delimCadena[1] = '\0';
	for(i=0;i<dr->numLineas;i++)
		{
		strcpy(copiaDeLinea, dr->lineas[i]);
		j=0;
		do
			{
			temp = strsep(&copiaDeLinea,delimCadena);
			mrs->m[i*mrs->numCols + j] = malloc(strlen(temp)+1);
			strcpy(mrs->m[i*mrs->numCols + j],temp);
			j++;
			} while (copiaDeLinea);
		copiaDeLinea = copiaDeLineaOri;
		}
	free(copiaDeLineaOri);
	return 1;
}

int extraerTablaAlfanumericaDeDocumentoPorColumnas(DocumentoRef dr, matRefs mrs)
{
	int i,j;
	int principioDelCampo;
	if (0 == dr->numLineas || 0 == dr->columnas[0] || NULL == dr->lineas) {
		printf("\nextraerTablaAlfanumericaDeDocumentoPorColumnas - documento incorrecto");
		return 0;
	}
	mrs->numRows = dr->numLineas;
	mrs->numCols = dr->numColumnas;
	mrs->m = malloc(mrs->numRows*mrs->numCols*sizeof(charRef));
	for(i=0;i<dr->numLineas;i++)
		{
		principioDelCampo = 0;
		for(j=0;j<dr->numColumnas;j++)
			{
			mrs->m[i*mrs->numCols+j] = trim(substring(dr->lineas[i], dr->lineas[i]+principioDelCampo, dr->columnas[j]));
			principioDelCampo += dr->columnas[j];
			}
		}
#ifdef __DEBUG__
	printf("\n\n");
	for (i=0; i<dr->numLineas; i++) {
		for (j=0; j<dr->numColumnas; j++) {
			printf(">>%s<<", mrs->m[i*dr->numColumnas+j]);
		}
		printf("\n");
	}
	printf("\n\n");
#endif
	return 1;
}

int extraerTablaDoubleDeTablaAlfanumerica(matRefs mrs, matRef mr)
{
	charRef endptr;
	double numero;
	int i,j;
	int numErrores = 0;
	mr->numRows = mrs->numRows;
	mr->numCols = mrs->numCols;
	mr->m = malloc(mr->numRows * mr->numCols*sizeof(double));
	for (i=0; i<mr->numRows; i++) {
		for (j=0; j<mr->numCols; j++) {
			numero = strtod(mrs->m[i*mrs->numCols+j], &endptr);
			if (endptr != mrs->m[i*mrs->numCols+j]) {
				mr->m[i*mr->numCols + j] = numero;
			}
			else {
				printf("\nFormato numrico incorrecto en m[%d][%d] = %s; toma el valor 0.0",i,j,mrs->m[i*mrs->numCols+j]);
				numErrores++;
			}
		}
	}
	return 0 == numErrores;
}

int extraerTablaIntDeTablaAlfanumerica(matRefs mrs, matRefi mri)
{
	charRef endptr;
	int numero;
	int i,j;
	int numErrores = 0;
	mri->numRows = mrs->numRows;
	mri->numCols = mrs->numCols;
	mri->m = malloc(mri->numRows * mri->numCols*sizeof(float));
	for (i=0; i<mri->numRows; i++) {
		for (j=0; j<mri->numCols; j++) {
			numero = strtol(mrs->m[i*mrs->numCols+j], &endptr,10);
			if (endptr != mrs->m[i*mrs->numCols+j]) {
				mri->m[i*mri->numCols + j] = numero;
			}
			else {
				printf("\nFormato numrico incorrecto en m[%d][%d] = %s; toma el valor 0.0",i,j,mrs->m[i*mrs->numCols+j]);
				numErrores++;
			}
			
		}
	}
	return 0 == numErrores;
}

int extraerTablaFloatDeTablaAlfanumerica(matRefs mrs, matReff mrf)
{
	charRef endptr;
	float numero;
	int i,j;
	int numErrores = 0;
	mrf->numRows = mrs->numRows;
	mrf->numCols = mrs->numCols;
	mrf->m = malloc(mrf->numRows * mrf->numCols*sizeof(float));
	for (i=0; i<mrf->numRows; i++) {
		for (j=0; j<mrf->numCols; j++) {
			numero = strtof(mrs->m[i*mrf->numCols+j], &endptr);
			if (endptr != mrs->m[i*mrf->numCols+j]) {
				mrf->m[i*mrf->numCols + j] = numero;
			}
			else {
				printf("\nFormato numrico incorrecto en m[%d][%d] = %s; toma el valor 0.0",i,j,mrs->m[i*mrs->numCols+j]);
				numErrores++;
			}
		}
	}
	return 0 == numErrores;
}
