#include "utmatrices.h"

	// Creacin de matrices

matRef newMat(int rowsWanted, int colsWanted){
	matRef temp;
	if (!(rowsWanted > 0 && colsWanted > 0)) {
		rowsWanted = pedirInt("Nmero de filas    : ", 1, MAX_ROWS);
		colsWanted = pedirInt("Nmero de columnas : ", 1, MAX_COLS);
	}
	temp = malloc(sizeof(mat));
	temp->m = malloc(rowsWanted*colsWanted*sizeof(double));
	temp->numRows = rowsWanted;
	temp->numCols = colsWanted;
	return temp;
}

matReff newMatf(int rowsWanted, int colsWanted){
	matReff temp;
	if (!(rowsWanted > 0 && colsWanted > 0)) {
		rowsWanted = pedirInt("Nmero de filas    : ", 1, MAX_ROWS);
		colsWanted = pedirInt("Nmero de columnas : ", 1, MAX_COLS);
	}
	temp = malloc(sizeof(matf));
	temp->m = malloc(rowsWanted*colsWanted*sizeof(float));
	temp->numRows = rowsWanted;
	temp->numCols = colsWanted;
	return temp;
}

matRefi newMati(int rowsWanted, int colsWanted){
	matRefi temp;
	if (!(rowsWanted > 0 && colsWanted > 0)) {
		rowsWanted = pedirInt("Nmero de filas    : ", 1, MAX_ROWS);
		colsWanted = pedirInt("Nmero de columnas : ", 1, MAX_COLS);
	}
	temp = malloc(sizeof(mati));
	temp->m = malloc(rowsWanted*colsWanted*sizeof(int));
	temp->numRows = rowsWanted;
	temp->numCols = colsWanted;
	return temp;
}

matRef newMatRandom(int rowsWanted, int colsWanted)
{
	int i;
	matRef temp = newMat(rowsWanted, colsWanted);
	srandomdev();
	for (i=0;i<temp->numCols*temp->numRows;i++){
		temp->m[i] = random();
	}
	return temp;
}

matReff newMatRandomf(int rowsWanted, int colsWanted)
{
	int i;
	matReff temp = newMatf(rowsWanted, colsWanted);
	srandomdev();
	for (i=0;i<temp->numCols*temp->numRows;i++){
		temp->m[i] = random();
	}
	return temp;
}

matRefi newMatRandomi(int rowsWanted, int colsWanted)
{
	int i;
	matRefi temp = newMati(rowsWanted, colsWanted);
	srandomdev();
	for (i=0;i<temp->numCols*temp->numRows;i++){
		temp->m[i] = random();
	}
	return temp;
}


	// Eliminacin de matrices

void matFree(matRef * mrr){
	matRef mr = *mrr;
	free(mr->m);
	mr->m = NULL;
	mr->numRows = 0;
	mr->numCols = 0;
}

void matFreef(matReff * mrr){
	matReff mr = *mrr;
	free(mr->m);
	mr->m = NULL;
	mr->numRows = 0;
	mr->numCols = 0;
}

void matFreei(matRefi * mrr){
	matRefi mr = *mrr;
	free(mr->m);
	mr->m = NULL;
	mr->numRows = 0;
	mr->numCols = 0;
}

	// Comprobacin

int badMat(matRef p){
	return NULL == p || NULL == p->m || p->numCols < 1 || p->numRows < 1;
}

int badMatf(matReff p){
	return NULL == p || NULL == p->m || p->numCols < 1 || p->numRows < 1;
}

int badMati(matRefi p){
	return NULL == p || NULL == p->m || p->numCols < 1 || p->numRows < 1;
}

	// Lectura de teclado

void matScan(matRef p, charRef c){
	int i,j;
	int lRows, lCols;
	if (badMat(p)) {
		printf("prettyReadMat() : la matriz %s no est definida correctamente.\n\n", c);
		return;
	}
	lRows = p->numRows;
	lCols = p->numCols;
	if (NULL == c) {
		c = "m";
	}
	for (i=0; i<lRows; i++) {
		for (j=0; j<lCols; j++) {
			printf("%s[%d][%d] = ",c,i,j);
			scanf("%lf%*c",p->m + i*lCols + j);
		}
	}
}

void matScanf(matReff p, charRef c){
	int i,j;
	int lRows, lCols;
	lRows = p->numRows;
	lCols = p->numCols;
	if (NULL == c) {
		c = "m";
	}
	for (i=0; i<lRows; i++) {
		for (j=0; j<lCols; j++) {
			printf("%s[%d][%d] = ",c,i,j);
			scanf("%f%*c",p->m + i*lCols + j);
		}
	}
}

void matScani(matRefi p, charRef c){
	int i,j;
	int lRows, lCols;
	lRows = p->numRows;
	lCols = p->numCols;
	if (NULL == c) {
		c = "m";
	}
	for (i=0; i<lRows; i++) {
		for (j=0; j<lCols; j++) {
			printf("%s[%d][%d] = ",c,i,j);
			scanf("%d%*c",p->m + i*lCols + j);
		}
	}
}

	// Escritura en pantalla

void matPrint(matRef p, charRef c){
	int i,j;
	int lRows, lCols;
	if (NULL == c) {
		c = " %g ";
	}
	if (badMat(p)) {
		printf("\n\nprettyPrintMat() - matriz incorrecta.\n\n");
		return;
	}
	lRows = p->numRows;
	lCols = p->numCols;
	for (i=0; i<lRows; i++) {
		printf("| ");
		for (j=0; j<lCols; j++) {
			printf(c,*(p->m+i*lCols+j));
		}
		printf(" |\n");
	}
}

void matPrintf(matReff p, charRef c){
	int i,j;
	int lRows, lCols;
	lRows = p->numRows;
	lCols = p->numCols;
	if (NULL == c) {
		c = " %g ";
	}
	for (i=0; i<lRows; i++) {
		printf("| ");
		for (j=0; j<lCols; j++) {
			printf(c,*(p->m+i*lCols+j));
		}
		printf(" |\n");
	}
}

void matPrinti(matRefi p, charRef c){
	int i,j;
	int lRows, lCols;
	lRows = p->numRows;
	lCols = p->numCols;
	if (NULL == c) {
		c = " %g ";
	}
	for (i=0; i<lRows; i++) {
		printf("| ");
		for (j=0; j<lCols; j++) {
			printf(c,*(p->m+i*lCols+j));
		}
		printf(" |\n");
	}
}

	// Escritura en disco

void matWrite(matRef m, charRef c){
	FILE * fp;
	int resultado_fwrite;
	int resultado_fclose;
	int numItems;
	if (badMat(m)) {
		printf("\n\nwriteMat() en %s - matriz incorrecta.\n\n",c);
		return;
	}
	if (NULL == c) {
		printf("\n\nwriteMat() en ruta incorrecta.\n\n");
	}
	fp = fopen(c, "wb");
	if (NULL == fp) {
		perror("writeMat() --- fopen() ---> ");
		return;
	}
	fwrite(&m->numRows, sizeof(int), 1, fp);
	fwrite(&m->numCols, sizeof(int), 1, fp);
	numItems = m->numRows*m->numCols;
	resultado_fwrite = fwrite(m->m, sizeof(double), numItems, fp);
	if (numItems != resultado_fwrite) {
		perror("writeMat() --- rows & cols ---> ");
		return;
	}
	resultado_fclose = fclose(fp);
	if (0 != resultado_fclose) {
		perror("writeMat() --- fclose() --->");
	}
}

void matWritef(matReff m, charRef c){
	FILE * fp;
	int resultado_fwrite;
	int resultado_fclose;
	int numItems;
	if (badMatf(m)) {
		printf("\n\nwriteMatF() en %s - matriz incorrecta.\n\n",c);
		return;
	}
	if (NULL == c) {
		printf("\n\nwriteMatF() en ruta incorrecta.\n\n");
	}
	fp = fopen(c, "wb");
	if (NULL == fp) {
		perror("writeMatF() --- fopen() ---> ");
		return;
	}
	fwrite(&m->numRows, sizeof(int), 1, fp);
	fwrite(&m->numCols, sizeof(int), 1, fp);
	numItems = m->numRows*m->numCols;
	resultado_fwrite = fwrite(m->m, sizeof(float), numItems, fp);
	if (numItems != resultado_fwrite) {
		perror("writeMatF() --- rows & cols ---> ");
		return;
	}
	resultado_fclose = fclose(fp);
	if (0 != resultado_fclose) {
		perror("writeMatF() --- fclose() --->");
	}
}

void matWritei(matRefi m, charRef c){
	FILE * fp;
	int resultado_fwrite;
	int resultado_fclose;
	int numItems;
	if (badMati(m)) {
		printf("\n\nwriteMatI() en %s - matriz incorrecta.\n\n",c);
		return;
	}
	if (NULL == c) {
		printf("\n\nwriteMatI() en ruta incorrecta.\n\n");
	}
	fp = fopen(c, "wb");
	if (NULL == fp) {
		perror("writeMatI() --- fopen() ---> ");
		return;
	}
	fwrite(&m->numRows, sizeof(int), 1, fp);
	fwrite(&m->numCols, sizeof(int), 1, fp);
	numItems = m->numRows*m->numCols;
	resultado_fwrite = fwrite(m->m, sizeof(int), numItems, fp);
	if (numItems != resultado_fwrite) {
		perror("writeMatI() --- rows & cols ---> ");
		return;
	}
	resultado_fclose = fclose(fp);
	if (0 != resultado_fclose) {
		perror("writeMatI() --- fclose() --->");
	}
}


	// Lectura de disco
matRef matRead(charRef ruta){
	FILE * fp;
	int num_rows, num_cols;
	int res_rows, res_cols, res_mat;
	matRef temp;
	int numItems;;
	if (NULL == ruta) {
		printf("\n\nreadMat() - ruta incorrecta.\n\n");
		return NULL;
	}
	fp = fopen(ruta, "rb");
	if (NULL == fp) {
		perror("readMat() --- fopen() ---> ");
		return NULL;
	}
	res_rows = fread(&num_rows, sizeof(int), 1, fp);
	res_cols = fread(&num_cols, sizeof(int), 1, fp);
	if (1 != res_rows || 1 != res_cols) {
		perror("readMat() --- rows & cols ---> ");
		fclose(fp);
		return NULL;
	}
	temp = malloc(sizeof(mat));
	temp->numRows = num_rows;
	temp->numCols = num_cols;
	temp->m = malloc(num_rows*num_cols*sizeof(double));
	numItems = num_rows*num_cols;
	res_mat = fread(temp->m, sizeof(double), numItems, fp);
	if (numItems != res_mat) {
		perror("reaMat() --- data ---> ");
		free(temp->m);
		free(temp);
		return NULL;
	}
	fclose(fp);
	return temp;
}

matReff matReadf(charRef ruta){
	FILE * fp;
	int num_rows, num_cols;
	int res_rows, res_cols, res_mat;
	matReff temp;
	if (NULL == ruta) {
		printf("\n\nreadMatF() - ruta incorrecta.\n\n");
		return NULL;
	}
	fp = fopen(ruta, "rb");
	if (NULL == fp) {
		perror("readMatF() ---> ");
		return NULL;
	}
	res_rows = fread(&num_rows, sizeof(int), 1, fp);
	res_cols = fread(&num_cols, sizeof(int), 1, fp);
	if (1 != res_rows || 1 != res_rows) {
		perror("readMatF() ---> ");
		fclose(fp);
		return NULL;
	}
	temp = malloc(sizeof(mat));
	temp->numRows = num_rows;
	temp->numCols = num_cols;
	temp->m = malloc(num_rows*num_cols*sizeof(float));
	res_mat = fread(temp->m, sizeof(float), num_rows*num_cols, fp);
	if (1 != res_mat) {
		perror("reaMatF() ---> ");
		free(temp->m);
		free(temp);
		return NULL;
	}
	fclose(fp);
	return temp;
}

matRefi matReadi(charRef ruta){
	FILE * fp;
	int num_rows, num_cols;
	int res_rows, res_cols, res_mat;
	matRefi temp;
	if (NULL == ruta) {
		printf("\n\nreadMatI() - ruta incorrecta.\n\n");
		return NULL;
	}
	fp = fopen(ruta, "rb");
	if (NULL == fp) {
		perror("readMatI() ---> ");
		return NULL;
	}
	res_rows = fread(&num_rows, sizeof(int), 1, fp);
	res_cols = fread(&num_cols, sizeof(int), 1, fp);
	if (1 != res_rows || 1 != res_rows) {
		perror("readMatI() ---> ");
		fclose(fp);
		return NULL;
	}
	temp = malloc(sizeof(mat));
	temp->numRows = num_rows;
	temp->numCols = num_cols;
	temp->m = malloc(num_rows*num_cols*sizeof(int));
	res_mat = fread(temp->m, sizeof(int), num_rows*num_cols, fp);
	if (1 != res_mat) {
		perror("reaMatI() ---> ");
		free(temp->m);
		free(temp);
		return NULL;
	}
	fclose(fp);
	return temp;
}

	// Exportacin a disco

void matExport(matRef mr, charRef ruta){
	int i,j;
	FILE * fp;
	int res_fclose;
	if (NULL == ruta) {
		printf("\n\nmatExport() - ruta incorrecta.\n\n");
		return;
	}
	if (badMat(mr)) {
		printf("\n\nmatExport() - matriz incorrecta.\n\n");
	}
	fp = fopen(ruta, "w");
	fprintf(fp, "%d\t%d\n", mr->numRows, mr->numCols);
	for (i=0;i<mr->numRows;i++)
		for (j=0; j<mr->numCols; j++) {
			fprintf(fp, "%g", *(mr->m+i*mr->numCols +j));
			fprintf(fp, j == mr->numCols - 1 ? "\n":"\t");
		}
	res_fclose = fclose(fp);
	if (res_fclose) {
		perror("matExport() --- fclose() --- ");
	}
}

void matExportf(matReff mr, charRef ruta){
	int i,j;
	FILE * fp;
	int res_fclose;
	if (NULL == ruta) {
		printf("\n\nmatExportf() - ruta incorrecta.\n\n");
		return;
	}
	if (badMatf(mr)) {
		printf("\n\nmatExportf() - matriz incorrecta.\n\n");
	}
	fp = fopen(ruta, "w");
	fprintf(fp, "%d\t%d\n", mr->numRows, mr->numCols);
	for (i=0;i<mr->numRows;i++)
		for (j=0; j<mr->numCols; j++) {
			fprintf(fp, "%g", *(mr->m+i*mr->numCols +j));
			fprintf(fp, j == mr->numCols - 1 ? "\n":"\t");
		}
	res_fclose = fclose(fp);
	if (res_fclose) {
		perror("matExportf() --- fclose() --- ");
	}
}

void matExporti(matRefi mr, charRef ruta){
	int i,j;
	FILE * fp;
	int res_fclose;
	if (NULL == ruta) {
		printf("\n\nmatExportf() - ruta incorrecta.\n\n");
		return;
	}
	if (badMati(mr)) {
		printf("\n\nmatExportf() - matriz incorrecta.\n\n");
	}
	fp = fopen(ruta, "w");
	fprintf(fp, "%d\t%d\n", mr->numRows, mr->numCols);
	for (i=0;i<mr->numRows;i++)
		for (j=0; j<mr->numCols; j++) {
			fprintf(fp, "%d", *(mr->m+i*mr->numCols +j));
			fprintf(fp, j == mr->numCols - 1 ? "\n":"\t");
		}
	res_fclose = fclose(fp);
	if (res_fclose) {
		perror("matExportf() --- fclose() --- ");
	}
}

	// Importacin de disco
matRef matImport(charRef ruta){
	int i,j;
	FILE * fp;
	int res_fscanf, res_fclose;
	matRef mr;
	if (NULL == ruta) {
		printf("\n\nmatImport() - ruta incorrecta.\n\n");
		return NULL;
	}
	fp = fopen(ruta, "r");
	if (NULL == fp) {
		perror("matImport() --- fopen()--- ");
		return NULL;
	}
	mr = malloc(sizeof(mat));
	res_fscanf = fscanf(fp, "%d\t%d\n", &(mr->numRows), &(mr->numCols));
	if (2 != res_fscanf) {
		perror("matImport() --- rows & cols --- ");
		fclose(fp);
		return NULL;
	}
	mr->m = malloc(mr->numRows*mr->numCols*sizeof(double));
	for (i=0;i<mr->numRows;i++)
		for (j=0; j<mr->numCols; j++){
			res_fscanf = fscanf(fp, "%lf", mr->m+i*mr->numCols +j);
			if (1 != res_fscanf) {
				perror("matImport() --- fscanf() --- ");
				matFree(&mr);
				return NULL;
			}
		}
	res_fclose = fclose(fp);
	if (res_fclose) {
		perror("matImport() --- fclose() --- ");
		matFree(&mr);
		return NULL;
	}
	return mr;
}

matReff matImportf(charRef ruta){
	int i,j;
	FILE * fp;
	int res_fscanf, res_fclose;
	matReff mr;
	if (NULL == ruta) {
		printf("\n\nmatImportf() - ruta incorrecta.\n\n");
		return NULL;
	}
	fp = fopen(ruta, "r");
	if (NULL == fp) {
		perror("matImportf() --- fopen()--- ");
		return NULL;
	}
	mr = malloc(sizeof(matf));
	res_fscanf = fscanf(fp, "%d\t%d\n", &(mr->numRows), &(mr->numCols));
	if (2 != res_fscanf) {
		perror("matImportf() --- rows & cols --- ");
		fclose(fp);
		return NULL;
	}
	mr->m = malloc(mr->numRows*mr->numCols*sizeof(double));
	for (i=0;i<mr->numRows;i++)
		for (j=0; j<mr->numCols; j++){
			res_fscanf = fscanf(fp, "%f", mr->m+i*mr->numCols +j);
			if (1 != res_fscanf) {
				perror("matImportf() --- fscanf() --- ");
				matFreef(&mr);
				return NULL;
			}
		}
	res_fclose = fclose(fp);
	if (res_fclose) {
		perror("matImportf() --- fclose() --- ");
		matFreef(&mr);
		return NULL;
	}
	return mr;
}

matRefi matImporti(charRef ruta){
	int i,j;
	FILE * fp;
	int res_fscanf, res_fclose;
	matRefi mr;
	if (NULL == ruta) {
		printf("\n\nmatImporti() - ruta incorrecta.\n\n");
		return NULL;
	}
	fp = fopen(ruta, "r");
	if (NULL == fp) {
		perror("matImporti() --- fopen()--- ");
		return NULL;
	}
	mr = malloc(sizeof(mati));
	res_fscanf = fscanf(fp, "%d\t%d\n", &(mr->numRows), &(mr->numCols));
	if (2 != res_fscanf) {
		perror("matImporti() --- rows & cols --- ");
		fclose(fp);
		return NULL;
	}
	mr->m = malloc(mr->numRows*mr->numCols*sizeof(double));
	for (i=0;i<mr->numRows;i++)
		for (j=0; j<mr->numCols; j++){
			res_fscanf = fscanf(fp, "%d", mr->m+i*mr->numCols +j);
			if (1 != res_fscanf) {
				perror("matImporti() --- fscanf() --- ");
				matFreei(&mr);
				return NULL;
			}
		}
	res_fclose = fclose(fp);
	if (res_fclose) {
		perror("matImporti() --- fclose() --- ");
		matFreei(&mr);
		return NULL;
	}
	return mr;
}

	// Operaciones matriciales

void matAdd(matRef a, matRef b, matRef c){
	int i, totalElements;
	int errorFactores=0, errorResultado=0;
	if (!(a->numRows == b->numRows && a->numCols == b->numCols)) {
		printf("\n\nError fatal: dos matrices de double no se pueden sumar.\n\n");
		errorFactores = 1;
	}
	if (!(a->numRows == c->numRows && a->numCols == c->numCols)) {
		printf("\n\nError fatal: la matriz suma de double tiene dimensiones incorrectas.\n\n");
		errorResultado = 1;
	}
	if (errorFactores ||errorResultado) {
		return;
	}
	totalElements = a->numRows*a->numCols;
	for (i=0; i<totalElements; i++) {
		c->m[i] = a->m[i]+ b->m[i];
	}
}

void matAddf(matReff a, matReff b, matReff c){
	int i, totalElements;
	int errorFactores=0, errorResultado=0;
	if (!(a->numRows == b->numRows && a->numCols == b->numCols)) {
		printf("\n\nError fatal: dos matrices de double no se pueden sumar.\n\n");
		errorFactores = 1;
	}
	if (!(a->numRows == c->numRows && a->numCols == c->numCols)) {
		printf("\n\nError fatal: la matriz suma de double tiene dimensiones incorrectas.\n\n");
		errorResultado = 1;
	}
	if (errorFactores ||errorResultado) {
		return;
	}
	totalElements = a->numRows*a->numCols;
	for (i=0; i<totalElements; i++) {
		c->m[i] = a->m[i]+ b->m[i];
	}
}

void matAddi(matRefi a, matRefi b, matRefi c){
	int i, totalElements;
	int errorFactores=0, errorResultado=0;
	if (!(a->numRows == b->numRows && a->numCols == b->numCols)) {
		printf("\n\nError fatal: dos matrices de double no se pueden sumar.\n\n");
		errorFactores = 1;
	}
	if (!(a->numRows == c->numRows && a->numCols == c->numCols)) {
		printf("\n\nError fatal: la matriz suma de double tiene dimensiones incorrectas.\n\n");
		errorResultado = 1;
	}
	if (errorFactores ||errorResultado) {
		return;
	}
	totalElements = a->numRows*a->numCols;
	for (i=0; i<totalElements; i++) {
		c->m[i] = a->m[i]+ b->m[i];
	}
}
