#ifndef __UTMATRICES_H__
#define __UTMATRICES_H__

#include <time.h>
#include "utiles.h"

#define MAX_ROWS 3500
#define MAX_COLS 3500

typedef struct mat {
	doubleRef m;
	int numRows, numCols;
} mat;
typedef mat * matRef;

typedef struct matf {
	floatRef m;
	int numRows, numCols;
} matf;
typedef matf * matReff;

typedef struct mati {
	intRef m;
	int numRows, numCols;
} mati;
typedef mati * matRefi;

typedef struct mats {
	charRef * m;
	int numRows, numCols;
} mats;
typedef mats * matRefs;

	// Creacin de matrices

matRef newMat(int rowsWanted, int colsWanted);
matReff newMatf(int rowsWanted, int colsWanted);
matRefi newMati(int rowsWanted, int colsWanted);

matRef newMatRandom(int rowsWanted, int colsWanted);
matReff newMatRandomf(int rowsWanted, int colsWanted);
matRefi newMatRandomi(int rowsWanted, int colsWanted);

	// Eliminacin de matrices

void matFree(matRef * m);
void matFreef(matReff * m);
void matFreei(matRefi * m);

	// Lectura y escritura a travs del teclado

void matPrint(matRef m, charRef c);
void matPrintf(matReff m, charRef c);
void matPrinti(matRefi m, charRef c);

void matScan(matRef m, charRef c);
void matScanf(matReff m, charRef c);
void matScani(matRefi m, charRef c);

	// Escritura y lectura en binario

void matWrite(matRef m, charRef ruta);
void matWritef(matReff m, charRef ruta);
void matWritei(matRefi m, charRef ruta);

matRef matRead(charRef ruta);
matReff matReadf(charRef ruta);
matRefi matReadi(charRef ruta);

	// Importacin y exportacin en un archivo de texto

matRef matImport(charRef ruta);
matReff matImportf(charRef ruta);
matRefi matImporti(charRef ruta);

void matExport(matRef mr, charRef ruta);
void matExportf(matReff mr, charRef ruta);
void matExporti(matRefi mr, charRef ruta);

	// Operaciones matriciales

void matAdd(matRef a, matRef b, matRef c);
void matAddf(matReff a, matReff b, matReff c);
void matAddi(matRefi a, matRefi b, matRefi c);

#endif
